<?php 
namespace app\controller;
use think\Controller;
use think\Db;
class Alipay extends Controller{
	public function index(){
		//显示产品页面,实际应用中这里可能会需要接收id,并显示详细产品
		return $this->fetch();
	}
	public function make_order(){
		//生成订单并传递参数到支付宝网关
		//对应支付宝demo中的pagepay/pagepay.php
		require_once EXTEND_PATH.'alipaypc/config.php'; //这里的配置文件是需要配置的
		require_once EXTEND_PATH.'alipaypc/pagepay/service/AlipayTradeService.php';
		require_once EXTEND_PATH.'alipaypc/pagepay/buildermodel/AlipayTradePagePayContentBuilder.php';
		 //商户订单号，商户网站订单系统中唯一订单号，必填
	    $order_num = time().rand(1,10); //生成唯一值, 这里只是一个例子
	    //订单名称，必填
	    $title = trim($_POST['title']) ; // 精确到分//付款金额，必填
	    $total_price = trim($_POST['total_price']) * 100;//商品描述，可空
	    $message = "";       
	    //将订单信息存进数据库
	    $data = [
	    			"title"       => $title,
	    			"total_price" => $total_price,
	    			"order_num"   => $order_num,
	    			"message"     => $message,
	    			"maketime"    => time(),
	    			"paystate"    => 1 //初始化为待支付状态
	    		];
	    Db::table("orders")->insert($data);
		//构造参数
		$payRequestBuilder = new \AlipayTradePagePayContentBuilder();
		$payRequestBuilder->setBody($message);
		$payRequestBuilder->setSubject($title);
		$payRequestBuilder->setTotalAmount($total_price);
		$payRequestBuilder->setOutTradeNo($order_num);

		$aop = new \AlipayTradeService($config);
		/**
		 * pagePay 电脑网站支付请求
		 * @param $builder 业务参数，使用buildmodel中的对象生成。
		 * @param $return_url 同步跳转地址，公网可以访问
		 * @param $notify_url 异步通知地址，公网可以访问
		 * @return $response 支付宝返回的信息
	 	*/
		$response = $aop->pagePay($payRequestBuilder,$config['return_url'],$config['notify_url']);
		//输出表单
		var_dump($response);
	}
	public function return_url(){
		//对就demo中的return_url.php
		require_once EXTEND_PATH.'alipaypc/config.php';
		require_once EXTEND_PATH.'alipaypc/pagepay/service/AlipayTradeService.php';


		$arr=$_GET;
		$alipaySevice = new \AlipayTradeService($config); 
		$result = $alipaySevice->check($arr);

		if($result) {//验证成功

			//商户订单号
			$out_trade_no = htmlspecialchars($_GET['out_trade_no']);
			$row = Db::table("orders")->where("order_num",$out_trade_no)->find();
			if($row["pagepay"] !== 2){
				//如果支付状态没有更新, 有可以已经通过异步更新了
				Db::table("orders")->where("order_num",$out_trade_no)->update(["paystate"=>2]);
				//更新支付状态为 2, 表示已经支付
			}

			//支付宝交易号
			$trade_no = htmlspecialchars($_GET['trade_no']);
				
			echo "验证成功<br />支付宝交易号：".$trade_no;

			//——请根据您的业务逻辑来编写程序（以上代码仅作参考）——
			
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		}
		else {
		    //验证失败
		    echo "验证失败";
		}
	}

	public function notify_url(){
		require_once EXTEND_PATH.'alipaypc/config.php';
		require_once EXTEND_PATH.'alipaypc/pagepay/service/AlipayTradeService.php';

		$arr=$_POST;
		$alipaySevice = new \AlipayTradeService($config); 
		$alipaySevice->writeLog(var_export($_POST,true));
		$result = $alipaySevice->check($arr);
		if($result) {//验证成功
			
			//商户订单号
			$out_trade_no = $_POST['out_trade_no'];
			//支付宝交易号
			$trade_no = $_POST['trade_no'];
			//交易状态
			$trade_status = $_POST['trade_status'];
		    if($_POST['trade_status'] == 'TRADE_FINISHED') {}
		    else if ($_POST['trade_status'] == 'TRADE_SUCCESS') {
				 Db::table("orders")->where("order_num",$out_trade_no)->update(["paystate"=>2]);
				//付款完成后，支付宝系统发送该交易状态通知
		    }
			//——请根据您的业务逻辑来编写程序（以上代码仅作参考）——
			echo "success";	//请不要修改或删除
		}else {
		    //验证失败
		    echo "fail";

		}
	}
}
?>